## GtkRecentFilter

GtkRecentFilter

## Functions

gboolean | (*GtkRecentFilterFunc) ()
GtkRecentFilter * | gtk_recent_filter_new ()
const gchar * | gtk_recent_filter_get_name ()
void | gtk_recent_filter_set_name ()
void | gtk_recent_filter_add_mime_type ()
void | gtk_recent_filter_add_pattern ()
void | gtk_recent_filter_add_pixbuf_formats ()
void | gtk_recent_filter_add_application ()
void | gtk_recent_filter_add_group ()
void | gtk_recent_filter_add_age ()
void | gtk_recent_filter_add_custom ()
GtkRecentFilterFlags | gtk_recent_filter_get_needed ()
gboolean | gtk_recent_filter_filter ()

## Types and Values

| GtkRecentFilter
struct | GtkRecentFilterInfo
enum | GtkRecentFilterFlags

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkRecentFilter

## Includes

    #include <gtk/gtk.h>

## Description

## Functions

### GtkRecentFilterFunc ()

    gboolean
    (*GtkRecentFilterFunc) (const GtkRecentFilterInfo *filter_info,
                            gpointer user_data);

### gtk_recent_filter_new ()

    GtkRecentFilter *
    gtk_recent_filter_new (void);

Creates a new GtkRecentFilter with no rules added to it. Such filter does not accept any recently used resources, so is not particularly useful until you add rules with `gtk_recent_filter_add_pattern()`, `gtk_recent_filter_add_mime_type()`, `gtk_recent_filter_add_application()`, `gtk_recent_filter_add_age()`. To create a filter that accepts any recently used resource, use:

    1
    2

    GtkRecentFilter *filter = gtk_recent_filter_new ();
    gtk_recent_filter_add_pattern (filter, "*");

#### Returns

a new GtkRecentFilter

Since: 2.10

### gtk_recent_filter_get_name ()

    const gchar *
    gtk_recent_filter_get_name (GtkRecentFilter *filter);

Gets the human-readable name for the filter. See `gtk_recent_filter_set_name()`.

#### Parameters

filter | a GtkRecentFilter |

#### Returns

the name of the filter, or `NULL`. The returned string is owned by the filter object and should not be freed.

Since: 2.10

### gtk_recent_filter_set_name ()

    void
    gtk_recent_filter_set_name (GtkRecentFilter *filter,
                                const gchar *name);

Sets the human-readable name of the filter; this is the string that will be displayed in the recently used resources selector user interface if there is a selectable list of filters.

#### Parameters

filter | a GtkRecentFilter |
name | then human readable name of `filter` |

Since: 2.10

### gtk_recent_filter_add_mime_type ()

    void
    gtk_recent_filter_add_mime_type (GtkRecentFilter *filter,
                                     const gchar *mime_type);

Adds a rule that allows resources based on their registered MIME type.

#### Parameters

filter | a GtkRecentFilter |
mime_type | a MIME type |

Since: 2.10

### gtk_recent_filter_add_pattern ()

    void
    gtk_recent_filter_add_pattern (GtkRecentFilter *filter,
                                   const gchar *pattern);

Adds a rule that allows resources based on a pattern matching their display name.

#### Parameters

filter | a GtkRecentFilter |
pattern | a file pattern |

Since: 2.10

### gtk_recent_filter_add_pixbuf_formats ()

    void
    gtk_recent_filter_add_pixbuf_formats (GtkRecentFilter *filter);

Adds a rule allowing image files in the formats supported by GdkPixbuf.

#### Parameters

filter | a GtkRecentFilter |

Since: 2.10

### gtk_recent_filter_add_application ()

    void
    gtk_recent_filter_add_application (GtkRecentFilter *filter,
                                       const gchar *application);

Adds a rule that allows resources based on the name of the application that has registered them.

#### Parameters

filter | a GtkRecentFilter |
application | an application name |

Since: 2.10

### gtk_recent_filter_add_group ()

    void
    gtk_recent_filter_add_group (GtkRecentFilter *filter,
                                 const gchar *group);

Adds a rule that allows resources based on the name of the group to which they belong

#### Parameters

filter | a GtkRecentFilter |
group | a group name |

Since: 2.10

### gtk_recent_filter_add_age ()

    void
    gtk_recent_filter_add_age (GtkRecentFilter *filter,
                               gint days);

Adds a rule that allows resources based on their age - that is, the number of days elapsed since they were last modified.

#### Parameters

filter | a GtkRecentFilter |
days | number of days |

Since: 2.10

### gtk_recent_filter_add_custom ()

    void
    gtk_recent_filter_add_custom (GtkRecentFilter *filter,
                                  GtkRecentFilterFlags needed,
                                  GtkRecentFilterFunc func,
                                  gpointer data,
                                  GDestroyNotify data_destroy);

Adds a rule to a filter that allows resources based on a custom callback function. The bitfield `needed` which is passed in provides information about what sorts of information that the filter function needs; this allows GTK+ to avoid retrieving expensive information when it isn't needed by the filter.

#### Parameters

filter | a GtkRecentFilter |
needed | bitfield of flags indicating the information that the custom filter function needs. |
func | callback function; if the function returns `TRUE`, then the file will be displayed. |
data | data to pass to `func` |
data_destroy | function to call to free `data` when it is no longer needed. |

Since: 2.10

### gtk_recent_filter_get_needed ()

    GtkRecentFilterFlags
    gtk_recent_filter_get_needed (GtkRecentFilter *filter);

Gets the fields that need to be filled in for the structure passed to `gtk_recent_filter_filter()`

This function will not typically be used by applications; it is intended principally for use in the implementation of GtkRecentChooser.

#### Parameters

filter | a GtkRecentFilter |

#### Returns

bitfield of flags indicating needed fields when calling `gtk_recent_filter_filter()`

Since: 2.10

### gtk_recent_filter_filter ()

    gboolean
    gtk_recent_filter_filter (GtkRecentFilter *filter,
                              const GtkRecentFilterInfo *filter_info);

Tests whether a file should be displayed according to `filter` . The GtkRecentFilterInfo structure `filter_info` should include the fields returned from `gtk_recent_filter_get_needed()`.

This function will not typically be used by applications; it is intended principally for use in the implementation of GtkRecentChooser.

#### Parameters

filter | a GtkRecentFilter |
filter_info | a GtkRecentFilterInfo structure containing information about a recently used resource |

#### Returns

`TRUE` if the file should be displayed

Since: 2.10

## Types and Values

### GtkRecentFilter

    typedef struct _GtkRecentFilter GtkRecentFilter;

### struct GtkRecentFilterInfo

    struct GtkRecentFilterInfo {
      GtkRecentFilterFlags contains;

      const gchar *uri;
      const gchar *display_name;
      const gchar *mime_type;
      const gchar **applications;
      const gchar **groups;

      gint age;
    };

### enum GtkRecentFilterFlags

#### Members

GTK_RECENT_FILTER_URI |  |
GTK_RECENT_FILTER_DISPLAY_NAME |  |
GTK_RECENT_FILTER_MIME_TYPE |  |
GTK_RECENT_FILTER_APPLICATION |  |
GTK_RECENT_FILTER_GROUP |  |
GTK_RECENT_FILTER_AGE |  |